Loading...
Searching...
No Matches
casacore::RegionHandlerTable Class Reference
images package (libcasa_images) » Regions_module » Regions_module_internal_classes

More...

`#include <RegionHandlerTable.h>`

## Public Types

typedef Table & | GetCallback(void *objectPtr, Bool writable)
Public Types inherited from casacore::RegionHandler
enum | GroupType { Regions , Masks , Any }
| Define the possible group types (regions or masks). More...

## Public Member Functions

| RegionHandlerTable (GetCallback *callback, void *objectPtr)
| RegionHandlerTable (const RegionHandlerTable &)
virtual | ~RegionHandlerTable ()
RegionHandlerTable & | operator= (const RegionHandlerTable &)
virtual RegionHandlerTable * | clone () const
| Make a copy of the object.
virtual void | setObjectPtr (void *objectPtr)
| Set the object pointer (for RegionHandlerTable's callback).
virtual Bool | canDefineRegion () const
| Can the class indeed define and handle regions?
virtual void | setDefaultMask (const String &maskName)
| Set the default mask to the mask with the given name.
virtual String | getDefaultMask () const
| Get the name of the default mask.
virtual Bool | defineRegion (const String &name, const ImageRegion &region, RegionHandler::GroupType, Bool overwrite=False)
| Define a region belonging to the table.
virtual Bool | hasRegion (const String &name, RegionHandler::GroupType=RegionHandler::Any) const
| Does the table have a region with the given name?
virtual ImageRegion * | getRegion (const String &name, RegionHandler::GroupType=Any, Bool throwIfUnknown=True) const
| Get a region belonging to the table.
virtual Bool | renameRegion (const String &newName, const String &oldName, RegionHandler::GroupType=Any, Bool overwrite=False)
| Rename a region.
virtual Bool | removeRegion (const String &name, RegionHandler::GroupType=Any, Bool throwIfUnknown=True)
| Remove a region belonging to the table.
virtual Vector< String > | regionNames (RegionHandler::GroupType=Any) const
| Get the names of all regions/masks.
virtual ImageRegion | makeMask (const LatticeBase &lattice, const String &name)
| Make a mask for a lattice (e.g.
Public Member Functions inherited from casacore::RegionHandler
virtual | ~RegionHandler ()
String | makeUniqueRegionName (const String &rootName, uInt startNumber=1) const
| Make a unique region name from the given root name, thus make it such that the name is not already in use for a region or mask.

## Private Member Functions

Table & | rwTable ()
const Table & | table () const
virtual Int | findRegionGroup (const String &regionName, RegionHandler::GroupType=Any, Bool throwIfUnknown=True) const

## Private Attributes

GetCallback * | itsCallback
void * | itsObjectPtr

## Detailed Description

Class for keeping regions in memory.

### Intended use:

Internal

### Review Status

Test programs:
  tPagedImage2

### Prerequisite

- PagedImage
- ImageRegion

### Synopsis

Persistent regions are stored as subrecords of the table keywords "regions" and "masks". The user can choose one of both keywords. Keyword "masks" is meant for true image masks, i.e. telling for each pixel if it is good or bad. Keyword "regions" is meant for true regions in an image.

This class handles defining, getting and removing such regions. It is used by class

Definition at line 86 of file RegionHandlerTable.h.

## Member Typedef Documentation

## GetCallback

typedef Table & casacore::RegionHandlerTable::GetCallback(void *objectPtr, Bool writable)

Definition at line 91 of file RegionHandlerTable.h.

## Constructor & Destructor Documentation

## RegionHandlerTable() [1/2]

casacore::RegionHandlerTable::RegionHandlerTable | ( | GetCallback * | callback,
|  | void * | objectPtr )

Referenced by clone(), operator=(), RegionHandlerTable(), and table().

## RegionHandlerTable() [2/2]

casacore::RegionHandlerTable::RegionHandlerTable | ( | const RegionHandlerTable & |  | ) |

References RegionHandlerTable().

## ~RegionHandlerTable()

virtual casacore::RegionHandlerTable::~RegionHandlerTable | ( |  | ) |

virtual

## Member Function Documentation

## canDefineRegion()

virtual Bool casacore::RegionHandlerTable::canDefineRegion | ( |  | ) | const

virtual

Can the class indeed define and handle regions?

The default implementation returns False.

Reimplemented from casacore::RegionHandler.

## clone()

virtual RegionHandlerTable * casacore::RegionHandlerTable::clone | ( |  | ) | const

virtual

Make a copy of the object.

Reimplemented from casacore::RegionHandler.

References RegionHandlerTable().

## defineRegion()

virtual Bool casacore::RegionHandlerTable::defineRegion | ( | const String & | name,
|  | const ImageRegion & | region,
|  | RegionHandler::GroupType | ,
|  | Bool | overwrite = False )

virtual

Define a region belonging to the table.

The group type determines if it stored as a region or mask. If overwrite=False, an exception will be thrown if the region already exists in the "regions" or "masks" keyword. Otherwise the region will be removed first.
A False status is returned if the table is not writable

Reimplemented from casacore::RegionHandler.

References casacore::False, and casacore::name().

## findRegionGroup()

virtual Int casacore::RegionHandlerTable::findRegionGroup | ( | const String & | regionName,
|  | RegionHandler::GroupType | = Any,
|  | Bool | throwIfUnknown = True ) const

private virtual

References casacore::RegionHandler::Any, and casacore::True.

## getDefaultMask()

virtual String casacore::RegionHandlerTable::getDefaultMask | ( |  | ) | const

virtual

Get the name of the default mask.

An empty string is returned if no default mask.

Reimplemented from casacore::RegionHandler.

## getRegion()

virtual ImageRegion * casacore::RegionHandlerTable::getRegion | ( | const String & | name,
|  | RegionHandler::GroupType | = Any,
|  | Bool | throwIfUnknown = True ) const

virtual

Get a region belonging to the table.

A zero pointer is returned if the region does not exist. The caller has to delete the ImageRegion object created.
No exception is thrown if the region does not exist.

Reimplemented from casacore::RegionHandler.

References casacore::RegionHandler::Any, casacore::name(), and casacore::True.

## hasRegion()

virtual Bool casacore::RegionHandlerTable::hasRegion | ( | const String & | name,
|  | RegionHandler::GroupType | = RegionHandler::Any ) const

virtual

Does the table have a region with the given name?

Reimplemented from casacore::RegionHandler.

References casacore::RegionHandler::Any, and casacore::name().

## makeMask()

virtual ImageRegion casacore::RegionHandlerTable::makeMask | ( | const LatticeBase & | lattice,
|  | const String & | name )

virtual

Make a mask for a lattice (e.g.

a PagedImage or TempImage). It creates it with the shape and tile shape of the lattice.

Reimplemented from casacore::RegionHandler.

References casacore::name().

## operator=()

RegionHandlerTable & casacore::RegionHandlerTable::operator= | ( | const RegionHandlerTable & |  | ) |

References RegionHandlerTable().

## regionNames()

virtual Vector< String > casacore::RegionHandlerTable::regionNames | ( | RegionHandler::GroupType | = Any | ) | const

virtual

Get the names of all regions/masks.

Reimplemented from casacore::RegionHandler.

References casacore::RegionHandler::Any.

## removeRegion()

virtual Bool casacore::RegionHandlerTable::removeRegion | ( | const String & | name,
|  | RegionHandler::GroupType | = Any,
|  | Bool | throwIfUnknown = True )

virtual

Remove a region belonging to the table.

Optionally an exception is thrown if the region does not exist.
A False status is returned if the table is not writable

Reimplemented from casacore::RegionHandler.

References casacore::RegionHandler::Any, casacore::name(), and casacore::True.

## renameRegion()

virtual Bool casacore::RegionHandlerTable::renameRegion | ( | const String & | newName,
|  | const String & | oldName,
|  | RegionHandler::GroupType | = Any,
|  | Bool | overwrite = False )

virtual

Rename a region.

If a region with the new name already exists, it is deleted or an exception is thrown (depending on overwrite). The region name is looked up in the given group(s).
An exception is thrown if the old region name does not exist.

Reimplemented from casacore::RegionHandler.

References casacore::RegionHandler::Any, and casacore::False.

## rwTable()

Table & casacore::RegionHandlerTable::rwTable | ( |  | ) |

inline private

Definition at line 174 of file RegionHandlerTable.h.

References itsCallback, itsObjectPtr, and casacore::True.

## setDefaultMask()

virtual void casacore::RegionHandlerTable::setDefaultMask | ( | const String & | maskName | ) |

virtual

Set the default mask to the mask with the given name.

It constructs a ImageRegion object for the new default mask. If the table is writable, the setting is persistent by writing the name as a keyword. If the given maskName is the empty string, the default mask is unset.

Reimplemented from casacore::RegionHandler.

## setObjectPtr()

virtual void casacore::RegionHandlerTable::setObjectPtr | ( | void * | objectPtr | ) |

virtual

Set the object pointer (for RegionHandlerTable's callback).

Default implementation does nothing.

Reimplemented from casacore::RegionHandler.

## table()

const Table & casacore::RegionHandlerTable::table | ( |  | ) | const

inline private

Definition at line 176 of file RegionHandlerTable.h.

References casacore::False, itsCallback, itsObjectPtr, and RegionHandlerTable().

## Member Data Documentation

## itsCallback

GetCallback* casacore::RegionHandlerTable::itsCallback

private

Definition at line 190 of file RegionHandlerTable.h.

Referenced by rwTable(), and table().

## itsObjectPtr

void* casacore::RegionHandlerTable::itsObjectPtr

private

Definition at line 191 of file RegionHandlerTable.h.

Referenced by rwTable(), and table().

The documentation for this class was generated from the following file:

- images/Regions/RegionHandlerTable.h